<?php
/**
 * Show options for ordering
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/loop/orderby.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see 	    https://docs.woocommerce.com/document/template-structure/
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.3.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

?>

<?php do_action( 'cloudfw_woocommerce_ordering_before' ); ?>

<form class="woocommerce-ordering clearfix" method="get">

	<select name="show_products" class="show_products" style="max-width: 120px;">
		<?php
			$show_products = isset($_GET['show_products']) ? $_GET['show_products'] : '';
			$catalog_show_products = apply_filters( 'woocommerce_catalog_show_products', array(
				''   => !empty($show_products) ? '' : cloudfw_translate('wc.catalog.display'),
				'12' => sprintf( cloudfw_translate('wc.catalog.d_products'), '12'),
				'24' => sprintf( cloudfw_translate('wc.catalog.d_products'), '24'),
				'32' => sprintf( cloudfw_translate('wc.catalog.d_products'), '32'),
				'48' => sprintf( cloudfw_translate('wc.catalog.d_products'), '48'),
			) );


			foreach ( $catalog_show_products as $id => $name )
				echo '<option value="' . esc_attr( $id ) . '" ' . selected( $show_products, $id, false ) . '>' . esc_attr( $name ) . '</option>';
		?>
	</select>

	<select name="orderby" class="orderby">
		<?php foreach ( $catalog_orderby_options as $id => $name ) : ?>
			<option value="<?php echo esc_attr( $id ); ?>" <?php selected( $orderby, $id ); ?>><?php echo esc_html( $name ); ?></option>
		<?php endforeach; ?>
	</select>
	<input type="hidden" name="paged" value="1" />
	<?php wc_query_string_form_fields( null, array( 'orderby', 'submit', 'paged' ) ); ?>
</form>
<div class="clear"></div>